import matplotlib.pyplot as plt
import numpy as np

# Solicitar al usuario que ingrese los datos
longitud = float(input("Ingrese la longitud de la viga en metros: "))
carga_distribuida = float(input("Ingrese la carga distribuida en N/m: "))

# Cálculo de reacciones
reaccion_A = carga_distribuida * longitud / 2
reaccion_B = carga_distribuida * longitud / 2

# Crear la figura y los ejes
fig, (ax1, ax2) = plt.subplots(2, 1, figsize=(10, 8))

# Dibujar la viga en todos los gráficos
for ax in (ax1, ax2):
    ax.plot([0, longitud], [0, 0], 'k', linewidth=8, label='Viga')

# Función de fuerza cortante
def fuerza_cortante(x):
    return reaccion_A - carga_distribuida * x

# Función de momento flector
def momento_flector(x):
    return reaccion_A * x - (carga_distribuida * x**2) / 2

# Generar puntos para la fuerza cortante y momento flector
x_vals = np.linspace(0, longitud, 500)
v_vals = [fuerza_cortante(x) for x in x_vals]
m_vals = [momento_flector(x) for x in x_vals]

# Dibujar la fuerza cortante
ax1.plot(x_vals, v_vals, 'b-', label='Fuerza Cortante')
ax1.set_title('Distribución de la Fuerza Cortante en la Viga')
ax1.set_ylabel('Fuerza Cortante (N)')
ax1.legend()

# Dibujar el momento flector
ax2.plot(x_vals, m_vals, 'r-', label='Momento Flector')
ax2.set_title('Distribución del Momento Flector en la Viga')
ax2.set_xlabel('Posición en la viga (m)')
ax2.set_ylabel('Momento Flector (Nm)')
ax2.legend()

# Mostrar el gráfico
plt.tight_layout()
plt.show()
